<template>
  <div class="goods-edit">
    <el-dialog title="添加商品" 
      :visible.sync="addData.isAdd">
      <el-form ref="formName" :rules="rules" :model="form">
        <el-row style="width:100%">
          <el-col :span="12" class="el-col">
            <el-form-item label="商品名称：" prop="goodsName">
              <el-input    
                v-model="form.goodsName"
                placeholder="请输入商品名称"
                clearable>
              </el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12" class="el-col">
            <el-form-item label="分类：" prop="goodsClassifyId">
              <el-select
                v-model="form.goodsClassify"
                filterable
                remote
                clearable
                placeholder="请输入分类"
                :remote-method="goodsClassifyRemote"
                style="margin-left:0px;"
                :loading="loading">
                <el-option
                  v-for="item in goodsClassifys"
                  :key="item.id"
                  :label="item.name"
                  :value="item.id">
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row style="width:100%">
          <el-col :span="12" class="el-col">
            <el-form-item label="价格：" prop="goodsPrice">
              <el-input    
                v-model="form.goodsPrice"
                placeholder="请输入价格"
                clearable>
              </el-input>
            </el-form-item>
          </el-col>
          <el-col :span="12" class="el-col">
            <el-form-item label="折扣率：" prop="discountRate">
              <el-input    
                v-model="form.discountRate"
                placeholder="请输入折扣率"
                clearable>
              </el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row style="width:100%">
          <el-col :span="12" class="el-col">
            <el-form-item label="折扣价：" prop="discountPrice">
              <el-input    
                v-model="form.discountPrice"
                placeholder="请输入折扣价"
                clearable>
              </el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row style="width:100%">
          <el-col :span="24" class="el-col">
            <el-form-item label="商品主图：" prop="url">
              <el-upload
                action="https://jsonplaceholder.typicode.com/posts/"
                list-type="picture-card"
                :on-preview="handlePictureCardPreview"
                :limit='1'
                :on-remove="handleRemove">
                <i class="el-icon-plus"></i>
              </el-upload>
              <el-dialog :visible.sync="dialogVisible">
                <img width="100%" :src="dialogImageUrl" alt="">
              </el-dialog>
              <span>商品主图大小为150px*150px</span>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="cancel">取 消</el-button>
        <el-button type="primary" @click="addGoods('formName')">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>

import {
  addGoods
} from '@/api/goodsManage/goodsManage'

export default {
  name: 'AddGoods',
  props:{
    addData:{
      type:Object
    }
  },
  data(){
    var checkDiscountPrice=(rule,value,callback)=>{
      var reg=/^-?\d+\.?\d{0,2}$/;
      console.log(reg.test(value));
      return callback()
    };
    return{
      form: {
        goodsName:23,
        goodsClassify:23,
        goodsClassifyId:23,
        goodsPrice:23,
        discountRate:0.2,
        discountPrice:23,
        goodsPictureId:23
      },
      rules:{
        goodsName:[
          {required:true,message:'请输入商品名称',trigger:'blur'}
        ],
        goodsClassifyId:[
          {required:true,message:'请选择商品分类',trigger:'blur'}
        ],
        goodsPrice:[
          {required:true,message:'请输入商品价格',trigger:'blur'}
        ],
        discountPrice:[
          {
            type:'number',
            validator:checkDiscountPrice,
            trigger:'blur'
          }
        ]
      },
      goodsClassifys:[

      ],
      dialogImageUrl: '',
      dialogVisible: false,
      loading:false
    }
  },
  created(){
  
  },
  methods:{
    addGoods(formName){
      this.$refs[formName].validate((valid) => {
        if(valid) {
            addGoods({
              coffeeCategoryId:this.form.goodsClassifyId,
              discountPrice:this.form.discountPrice,
              discountRate:this.form.discountRate,
              mainPicId:this.form.goodsPictureId,
              name: this.form.goodsName,
              price:this.form.goodsPrice
            }).then((res)=>{
              if(res.code=='000000'){
                this.$message({
                  message: '添加成功！',
                  type: 'success'
                });
                this.$refs[formName].clearValidate();
              }
            })
        } else {
          return false;
        }
      }); 
    },
    goodsClassifyRemote(){

    },
    handleRemove(file, fileList) {
        console.log(file, fileList);
    },
    handlePictureCardPreview(file) {
      this.dialogImageUrl = file.url;
      this.dialogVisible = true;
    },
    cancel(){
      this.addData.isAdd=false;
    },
  }
}
</script>

<style lang="less" scoped>
  /deep/.el-dialog{
    .el-dialog__header{
      text-align: left;
      background-color: #f2f2f2;;
    }
    .dialog-footer{
      text-align: center;
    }
  }
  /deep/.el-form{
    .el-form-item{
      display: flex;
      .el-form-item__label{
        width: 150px;
        flex-shrink:0;
      }
      .el-form-item__content{
        margin-left: 0 !important;
        .del-button{
          position: relative;
          top: -50px;
          left: 20px;
        }
      }
    }
  }
</style>
